import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

public class midlet extends MIDlet { 
 private boolean isStarted = false;
 Locale locale = new Locale();
 Command QUIT_CMD, BACK_CMD, DETAILS_CMD, SEARCH_CMD;
 String filePath = "/data.xml";
    
 public void showElement (XMLElement elem, Displayable parent) { 
  if (elem.getAttributes() != null || elem.getValue() != null) { 
   new ElementForm(elem, this, parent);
  } 
  else { 
   new ElementList(elem, this, parent);
  }
 }

 public midlet () { 
  XMLParser parser;
  String language = getAppProperty("language");
  locale = new Locale(language != null ? language : "ru");
  QUIT_CMD = new Command(locale.getResource("Quit"), Command.BACK, 2);
  BACK_CMD = new Command(locale.getResource("Back"), Command.BACK, 2);
  DETAILS_CMD = new Command(locale.getResource("Details"), Command.ITEM, 1);
  SEARCH_CMD = new Command(locale.getResource("Search"), Command.ITEM, 2);
  if ("ru".equals(locale.getLanguage())) { 
   parser = new XMLParser(new CyrillicWinReader(getClass().getResourceAsStream(filePath)));
  } 
  else { 
   parser = new XMLParser(filePath);
  }
  rootElem = parser.getRoot();
  try { 
   itemImage = Image.createImage("/icons/item.png");
  } 
  catch (IOException err) {}
 }

 protected void destroyApp(boolean unconditional) {}

 protected  void pauseApp() {}

 protected void startApp() {
  if (isStarted) { return; }
  isStarted = true;
  showElement(rootElem, null);
 }

 public void quit() { 
  destroyApp(true);
  notifyDestroyed();
 }

 XMLElement rootElem;
 Image itemImage;

}    
           